QB64 is a modern extended BASIC programming language that retains QBasic / Quick BASIC 4.5 compatibility and compiles native binaries for Windows, Linux, and macOS.

## Getting started

* Grab the latest version of QB64 from our active [GitHub repo](https://github.com/QB64Official/qb64/releases/latest).

### FAQ

* [QB64 FAQ](QB64-FAQ)

### Get in touch

* [Official QB64 Discord Server Invitation](https://discord.gg/A3HmUe2mv8)

## Keywords

* [Keyword Reference (Alphabetical)](Keyword-Reference-(Alphabetical))
* [Keyword Reference (By Usage)](Keyword-Reference-(Usage))

### Known issues

* [Keywords currently not supported by QB64](Keywords-currently-not-supported-by-QB64)

## Articles and Tutorials

* [Terry Ritchie's QB64 Game Programming](http://www.qb64sourcecode.com)
* [School Freeware series on QB64 (YouTube)](https://www.youtube.com/watch?v=hE-Voij5k5Q&list=PLF6199808BD4901E1)
* [Arrays](Arrays)
* [ASCII](ASCII)
* [Binary](Binary)
* [Boolean](Boolean)
* [_CLIPBOARD$](_CLIPBOARD$)
* [Converting Bytes to Bits](Converting-Bytes-to-Bits)
* [Console Window](Console-Window)
* [Controller Devices](Controller-Devices) (Keyboard, Mouse, Joystick, Gamepad)
* [Downloading Files](Downloading-Files) (TCP/IP)
* [Windows Environment](Windows-Environment)
* [Hardware images](Hardware-images)
* [Images](Images)
* [Keyboard scancodes](Keyboard-scancodes)
* [Libraries](Libraries) ([C Libraries](C-Libraries), [Windows Libraries](Windows-Libraries), [DLL Libraries](DLL-Libraries))
* [Mathematical Operations](Mathematical-Operations)
* [PDS (7.1) Procedures](PDS-(7.1)-Procedures)
* [Port Access Libraries](Port-Access-Libraries)
* [QB 4.5 Library Ports For QB64](QB-4.5-Library-Ports-For-QB64)
* [Relational Operations](Relational-Operations)
* [Line numbers](Line-numbers)
* [Line number](Line-number)
* [Resource Table extraction](Resource-Table-extraction)
* [Screen Memory](Screen-Memory)
* [Text Using Graphics](Text-Using-Graphics)
* [Variable Types](Variable-Types)